
//
// To jest przykadowy kod z podrozdziau 23.8.7 Bdy w wyraeniach regularnych ksiki
// "Programowanie. Teoria i praktyka z wykorzystaniem C++" Bjarne'a Stroustrupa.
//

#include <boost/regex.hpp>
#include <iostream>
#include <string>

using namespace std;
using namespace boost;

//------------------------------------------------------------------------------

void wrong_patterns()
{
    regex pat1("(|ghi)");    // brakuje alternatywy
    regex pat2("[c-a]");     // nie przedzia
}

//------------------------------------------------------------------------------

// wzorzec i zestaw wierszy zostaj przyjte na wejciu,
// wzorzec zostaje sprawdzony i nastpuje wyszukanie odpowiadajcych mu wierszy.

int main()
{
    regex pattern;

    string pat;
    cout << "Wprowad wzorzec: ";
    getline(cin,pat);        // wczytuje wzorzec

    try {
        pattern = pat;       // sprawdza pat
        cout << "Wzorzec: " << pattern << '\n';
    }
    catch (bad_expression) {
        cout << pat << " nie jest poprawnym wyraeniem regularnym.\n";
        exit(1);
    }

    cout << "Wprowad tekst:\n";
    string line;             // bufor wejciowy
    int lineno = 0;

    while (getline(cin,line)) {
        ++lineno;
        smatch matches;
        if (regex_search(line, matches, pattern)) {
            cout << "Wiersz " << lineno << ": " << line << '\n';
            for (int i = 0; i<matches.size(); ++i)
                cout << "\tpasuje[" << i << "]: "
                     <<  matches[i]  << '\n';
        }
        else
            cout << "nie pasuje\n";
    }
}

//------------------------------------------------------------------------------
